<?php

// Log types
define('LOG_TYPE_TRANSLATION', 1);
define('LOG_TYPE_DOWNLOAD', 2);
define('LOG_TYPE_USER', 3);
define('LOG_TYPE_MODERATOR', 4);
define('LOG_TYPE_ERROR', 10);
define('LOG_TYPE_IMPORT', 11);
define('LOG_TYPE_EXPORT', 12);
define('LOG_TYPE_CZWOW', 13);
define('LOG_TYPE_ADMINISTRATION', 14);


function utf2ascii($text)
{
  $return = Str_Replace(
    Array("á","č","ď","é","ě","í","ľ","ň","ó","ř","š","ť","ú","ů","ý","ž","Á","Č","Ď","É","Ě","Í","Ľ","Ň","Ó","Ř","Š","Ť","Ú","Ů","Ý","Ž") ,
    Array("a","c","d","e","e","i","l","n","o","r","s","t","u","u","y","z","A","C","D","E","E","I","L","N","O","R","S","T","U","U","Y","Z") ,
    $text);
  //$return = Str_Replace(Array(" ", "_"), "-", $return); //nahradí mezery a podtržítka pomlčkami
  //$return = Str_Replace(Array("(",")",".","!",",","\"","'"), "", $return); //odstraní ().!,"'
  //$return = StrToLower($return); // velká písmena nahradí malými.
  return($return);
}

function getmonthyears($Days) 
{
  $month = floor($Days / 30);
  $year = floor($month / 12);
  $Days = floor($Days - $month * 30);
  $month = $month - $year * 12; 
  return($year.'r '.$month.'m '.$Days.'d');
}

function GetPageList($TotalCount)
{
  global $Database, $Config;
    
  $QueryItems = GetQueryStringArray($_SERVER['QUERY_STRING']);
  
  $ItemPerPage = $Config['Web']['ItemsPerPage'];
  $Around = round($Config['Web']['VisiblePagingItems'] / 2);
  $Result = '';
  $PageCount = floor($TotalCount / $ItemPerPage) + 1;
  
  if(!array_key_exists('Page', $_SESSION)) $_SESSION['Page'] = 0;
  if(array_key_exists('page', $_GET)) $_SESSION['Page'] = $_GET['page'] * 1;
  if($_SESSION['Page'] < 0) $_SESSION['Page'] = 0;
  if($_SESSION['Page'] >= $PageCount) $_SESSION['Page'] = $PageCount - 1;
  $CurrentPage = $_SESSION['Page'];
  
        
  $Result .= 'Počet položek: <strong>'.$TotalCount.'</strong> &nbsp; Stránky: ';

  $Result = '';
  if($PageCount > 1)
  {
    if($CurrentPage > 0) 
    {
      $QueryItems['page'] = 0;      
      $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&lt;&lt;</a> ';
      $QueryItems['page'] = ($CurrentPage - 1);
      $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&lt;</a> ';
    }
    $PagesMax = $PageCount - 1;
    $PagesMin = 0;
    if($PagesMax > ($CurrentPage + $Around)) $PagesMax = $CurrentPage + $Around;
    if($PagesMin < ($CurrentPage - $Around))
    {
      $Result.= ' ... ';
      $PagesMin = $CurrentPage - $Around;
    }
    for($i = $PagesMin; $i <= $PagesMax; $i++)
    {
      if($i == $CurrentPage) $Result.= '<strong>'.($i + 1).'</strong> ';
      else {
       $QueryItems['page'] = $i;
       $Result .= '<a href="?'.SetQueryStringArray($QueryItems).'">'.($i + 1).'</a> ';
      }
    } 
    if($PagesMax < ($PageCount - 1)) $Result .= ' ... ';
    if($CurrentPage < ($PageCount - 1)) 
    {
      $QueryItems['page'] = ($CurrentPage + 1);
      $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&gt;</a> ';
      $QueryItems['page'] = ($PageCount - 1);
      $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&gt;&gt;</a>';
    }
  }
  $Result = '<div style="text-align: center">'.$Result.'</div>';
  return(array('SQLLimit' => ' LIMIT '.$CurrentPage * $ItemPerPage.', '.$ItemPerPage, 
    'Page' => $CurrentPage,
    'Output' => $Result,
  ));
}

$OrderDirSQL = array('ASC', 'DESC');
$OrderArrowImage = array('sort_asc.png', 'sort_desc.png');

function GetOrderTableHeader($Columns, $DefaultColumn, $DefaultOrder = 0)
{
  global $OrderDirSQL, $OrderArrowImage, $Config, $System;
  
  if(array_key_exists('OrderCol', $_GET)) $_SESSION['OrderCol'] = $_GET['OrderCol'];
  if(array_key_exists('OrderDir', $_GET)) $_SESSION['OrderDir'] = $_GET['OrderDir'];
  if(!array_key_exists('OrderCol', $_SESSION)) $_SESSION['OrderCol'] = $DefaultColumn;
  if(!array_key_exists('OrderDir', $_SESSION)) $_SESSION['OrderDir'] = $DefaultOrder;
  
  // Check OrderCol
  $Found = false;
  foreach($Columns as $Column)
  {
    if($Column['Name'] == $_SESSION['OrderCol'])
    {
      $Found = true;    
      break;
    }
  }
  if($Found == false)
  {
    $_SESSION['OrderCol'] = $DefaultColumn;
    $_SESSION['OrderDir'] = $DefaultOrder;
  }
  // Check OrderDir
  if(($_SESSION['OrderDir'] != 0) and ($_SESSION['OrderDir'] != 1)) $_SESSION['OrderDir'] = 0;
  
  $Result = '';
  $QueryItems = GetQueryStringArray($_SERVER['QUERY_STRING']);
  foreach($Columns as $Index => $Column)
  {
    $QueryItems['OrderCol'] = $Column['Name'];
    $QueryItems['OrderDir'] = 1 - $_SESSION['OrderDir'];
    if($Column['Name'] == $_SESSION['OrderCol']) $ArrowImage = '<img  style="vertical-align: middle; border: 0px;" src="'.$System->Link('/images/'.$OrderArrowImage[$_SESSION['OrderDir']]).'" alt="order arrow">';
      else $ArrowImage = '';
    if($Column['Name'] == '') $Result .= '<th>'.$Column['Title'].'</th>';
      else $Result .= '<th><a href="?'.SetQueryStringArray($QueryItems).'">'.$Column['Title'].$ArrowImage.'</a></th>';
  }
  return(array(
    'SQL' => ' ORDER BY `'.$_SESSION['OrderCol'].'` '.$OrderDirSQL[$_SESSION['OrderDir']],
    'Output' => '<tr>'.$Result.'</tr>',
    'Column' => $_SESSION['OrderCol'],
    'Direction' => $_SESSION['OrderDir'],
  ));
}

function FormatOutput($s)
{
    $out = '';
    $nn = 0;
    $n = 0;
    while($s!='')
    {
      $start = strpos($s,'<');
      $end = strpos($s,'>');
      if($start != 0) 
      {
        $end = $start-1;
        $start = 0;
      }
      $line = trim(substr($s,$start,$end+1));
      if(strlen($line)>0) 
      if($line[0] == '<')
      {
        if($s[$start+1] == '/') 
        {
          $n = $n - 2;
          $nn = $n;
        } else 
        {
          if(strpos($line,' ')) $cmd = substr($line,1,strpos($line,' ')-1);
          else $cmd = substr($line,1,strlen($line)-2);
          //echo('['.$cmd.']');
          if(strpos($s,'</'.$cmd.'>')) $n = $n + 2;
        }   
      }// else $line = '['.$line.']';
      //if($line != '') echo(htmlspecialchars(str_repeat(' ',$nn).$line."\n"));
      if($line != '') $out .= (str_repeat(' ',$nn).$line."\n");
      $s = substr($s,$end+1,strlen($s));
      $nn = $n;
    }
    return($out);
}

function WriteLanguages($Selected)
{
  global $LanguageList;
  
  echo('<select name="Language">');
  foreach($LanguageList as $Language)
  if($Language['Enabled'] == 1)
  {
    echo('<option value="'.$Language['Id'].'"'); 
    if($Selected == $Language['Id']) echo(' selected="selected"'); echo('>'.$Language['Name'].'</option>');
  }    
  echo('</select>');    
}

function WriteLanguagesWithoutSel($Selected)
{
  global $LanguageList;
  
  foreach($LanguageList as $Language)
  {
    if($Selected == $Language['Id']) echo($Language['Name']);
  }
}

function MysqlDateTimeToTime($Time)
{
  $Parts = explode(' ', $Time);
  $DateParts = explode('-', $Parts[0]); 
  $TimeParts = explode(':', $Parts[1]);
  $Result = mktime($TimeParts[0], $TimeParts[1], $TimeParts[2], $DateParts[1], $DateParts[2], $DateParts[0]); 
  return($Result);  
}

function GetLanguageList()
{ 
  global $Database;
  
  $Result = array();
  $DbResult = $Database->SQLCommand('SELECT * FROM `Language` WHERE `Enabled` = 1');
  while($DbRow = mysql_fetch_assoc($DbResult))
    $Result[$DbRow['Id']] = $DbRow;
  return($Result);
}

function GetTranslationTree()
{ 
  global $Database;
  
  $Result = array();
  $DbResult = $Database->SQLCommand('SELECT *, UNIX_TIMESTAMP(`LastImport`) AS `LastImportTime` FROM `Group` ORDER BY `Name`');
  while($DbRow = mysql_fetch_assoc($DbResult))
  {
    $DbRow['Items'] = array();
    $Result[$DbRow['Id']] = $DbRow;
  }
  $DbResult = $Database->SQLCommand('SELECT * FROM `GroupItem` ORDER BY `Sequence`');
  while($DbRow = mysql_fetch_assoc($DbResult))
  {
    $Result[$DbRow['Group']]['Items'][$DbRow['Sequence']] = $DbRow;
  }
  return($Result);
}

$Moderators = array('Překladatel', 'Moderátor', 'Administrátor');

function WriteLog($Text, $Type)
{
  global $Database, $Config, $User;
 
  if(!isset($_SERVER['REMOTE_ADDR'])) $IP = 'Konzole';
    else $IP = addslashes($_SERVER['REMOTE_ADDR']);

  $Database->SelectDatabase($Config['Database']['Database']);    
  $Query = 'INSERT INTO `Log` ( `User` , `Type` , `Text` , `Date` , `IP` )
   VALUES ('.$User->Id.', '.$Type.', "'.addslashes($Text).'", NOW(), "'.$IP.'")';
  $Database->SQLCommand($Query);
}

function HumanDate($SQLDateTime)
{
  $DateTimeParts = explode(' ', $SQLDateTime);
  if($DateTimeParts[0] != '0000-00-00')
  {
    $DateParts = explode('-', $DateTimeParts[0]);
    return(($DateParts[2] * 1).'.'.($DateParts[1] * 1).'.'.($DateParts[0] * 1));
  } else return('&nbsp;');
}

function FollowingTran($TextID, $Table, $GroupId, $Prev = false) 
{ 
  global $Database;
  
  if($Prev)
  {
    $sql = 'SELECT ID FROM '.$Table.' as item WHERE Language = 0 AND NOT EXISTS(SELECT entry FROM '.$Table.' AS sub WHERE sub.Language <> 0 AND sub.entry = item.entry) AND ID < '.$TextID.' ORDER BY ID DESC LIMIT 1';
  } else
  {
    $sql = 'SELECT ID FROM '.$Table.' as item WHERE Language = 0 AND NOT EXISTS(SELECT entry FROM '.$Table.' AS sub WHERE sub.Language <> 0 AND sub.entry = item.entry) AND ID > '.$TextID.' ORDER BY ID LIMIT 1';
  }
  
  $Next = mysql_fetch_assoc($Database->SQLCommand($sql));
  if($Next) 
  {
    if($Prev) echo('<a href="form.php?group='.$GroupId.'&amp;ID='.$Next['ID'].'">Předcházející '.$Next['ID'].'</a> ');
    else echo('<a href="form.php?group='.$GroupId.'&amp;ID='.$Next['ID'].'">Následující '.$Next['ID'].'</a> ');
      return 'form.php?group='.$GroupId.'&amp;ID='.$Next['ID'];
  }
}

function GetBuildNumber($Version)
{
  global $Database, $BuildNumbers;
  
  if(isset($BuildNumbers[$Version]) == false) 
  {
    $sql = 'SELECT `BuildNumber` FROM `ClientVersion` WHERE `Version` = "'.$Version.'"';
    $DbRow = mysql_fetch_assoc($Database->SQLCommand($sql));
    $BuildNumbers[$Version] = $DbRow['BuildNumber'];
  }
  return($BuildNumbers[$Version]);
}

function GetVersionWOW($BuildNumber)
{
  global $Database, $VersionsWOW;
  
  if(isset($VersionsWOW[$BuildNumber]) == false) 
  {
    $sql = 'SELECT `Version` FROM `ClientVersion` WHERE `BuildNumber` = "'.$BuildNumber.'"';
    $Version = mysql_fetch_assoc($Database->SQLCommand($sql));
    $VersionsWOW[$BuildNumber] = $Version['Version'];
  }
  return($VersionsWOW[$BuildNumber]);
}

function GetDBCColumns($Version, $DBCFileName)
{
  global $Database, $DBCColumns;
  
  if(isset($DBCColumns[$Version][$DBCFileName]) == false) 
  {
    $sql = 'SELECT `DBCColumns_'.$DBCFileName.'` AS `DBCColumns` FROM `ClientVersion` WHERE `Version` = "'.$Version.'"';
    $DbRow = mysql_fetch_assoc($Database->SQLCommand($sql));
    $DBCColumns[$Version][$DBCFileName] = $DbRow['DBCColumns'];
  }
  return($DBCColumns[$Version][$DBCFileName]);
}

function GetDBCColumnIndex($Version, $DBCFileName, $Column)
{
  global $Database, $DBCColumnIndex;
  
  if(isset($DBCColumnIndex[$Version][$DBCFileName][$Column]) == false) 
  {
    $sql = 'SELECT `'.$DBCFileName.'_'.$Column.'` AS `DBCColumns` FROM `ClientVersion` WHERE `Version` = "'.$Version.'"';
    $DbRow = mysql_fetch_assoc($Database->SQLCommand($sql));
    $DBCColumnIndex[$Version][$DBCFileName][$Column] = $DbRow['DBCColumns'];
  }
  return($DBCColumnIndex[$Version][$DBCFileName][$Column]);
}

function LoadGroupIdParameter()
{
  global $TranslationTree;
  
  if(array_key_exists('group', $_GET)) $GroupId = $_GET['group'] * 1; 
    else $GroupId = 1;
  
  if(isset($TranslationTree[$GroupId]) == false)
  {
    echo('Překladová skupina dle zadaného Id neexistuje.');
    ShowFooter();
    die();
  }
  return($GroupId);
}

function LoadLanguageIdParameter()
{
  global $LanguageList;
  
  if(array_key_exists('language', $_GET)) $LanguageId = $_GET['language'] * 1; 
    else $LanguageId = 1;
  
  if(isset($LanguageList[$LanguageId]) == false)
  {
    echo('Jazyk dle zadaného Id neexistuje.');
    ShowFooter();
    die();
  }
  return($LanguageId);
}

function LoadCommandLineParameters()
{
  if(!array_key_exists('REMOTE_ADDR', $_SERVER))
  {
    foreach($_SERVER['argv'] as $Parameter)
    {
      if(strpos($Parameter, '=') !== false)
      {
        $Index = substr($Parameter, 0, strpos($Parameter, '='));
        $Parameter = substr($Parameter, strpos($Parameter, '=') + 1);
        //echo($Index.'  ----  '.$Parameter);
        $_GET[$Index] = $Parameter;
      }
    } 
  }
}

function ShowTabs($Tabs)
{
  $QueryItems = GetQueryStringArray($_SERVER['QUERY_STRING']);
  
  if(array_key_exists('Tab', $_GET)) $_SESSION['Tab'] = $_GET['Tab'];
  if(!array_key_exists('Tab', $_SESSION)) $_SESSION['Tab'] = 0;
  if(($_SESSION['Tab'] < 0) or ($_SESSION['Tab'] > (count($Tabs) - 1))) $_SESSION['Tab'] = 0;
  echo('<div id="header">');
  echo('<ul>');
  foreach($Tabs as $Index => $Tab)
  {
    $QueryItems['Tab'] = $Index;
    if($Index == $_SESSION['Tab']) $Selected = ' id="selected"'; 
      else $Selected = '';
    echo('<li'.$Selected.'><a href="?'.SetQueryStringArray($QueryItems).'">'.$Tab.'</a></li>');
  }
  echo('</ul></div>');
}

function CheckBox($Name, $Checked = false, $Id = '', $Class = '', $Disabled = false)
{
  if($Id) $Id = ' id="'.$Id.'"'; else $Id = '';
  if($Class) $Class = ' class="'.$Class.'"'; else $Class = '';
  if($Checked) $Checked = ' checked="checked"'; else $Checked = '';
  if($Disabled) $Disabled = ' disabled="disabled"'; else $Disabled = '';
  return('<input type="checkbox" value="checked" name="'.$Name.'"'.$Checked.$Disabled.$Id.$Class.' />');
}

function RadioButton($Name, $Value, $Checked = false, $OnClick = '', $Disabled = false)
{
  if($Checked) $Checked = ' checked="checked"'; else $Checked = '';
  if($OnClick != '') $OnClick = ' onclick="'.$OnClick.'"'; else $OnClick = '';
  if($Disabled) $Disabled = ' disabled="disabled"'; else $Disabled = '';
  return('<input type="radio" name="'.$Name.'" value="'.$Value.'"'.$Checked.$Disabled.$OnClick.'/>');
}

function SelectOption($Name, $Text, $Selected = false)
{
  if($Selected) $Selected = ' selected="selected"'; else $Selected = '';
  return('<option value="'.$Name.'"'.$Selected.'>'.$Text.'</option>');
}

function DeleteDirectory($dirname) 
{
  if(is_dir($dirname))
  {
    $dir_handle = opendir($dirname);
    if(!$dir_handle) return(false);
    while($file = readdir($dir_handle)) 
    {
      if(($file != '.') and ($file != '..'))
      {
        if(!is_dir($dirname.'/'.$file)) unlink($dirname.'/'.$file);
          else DeleteDirectory($dirname.'/'.$file);    
      }
    }
    closedir($dir_handle);
    rmdir($dirname);
  }
  return(true);
}

function ErrorMessage($Text)
{
  echo($Text);
  ShowFooter();
  die();
}

function GetIDbyName($Table) 
{
  global $TranslationTree;
  
  foreach($TranslationTree as $TableID => $Value) 
  {
    //echo $Value['TablePrefix'].'='.$Table.'<br>';
    if($Value['TablePrefix'] == $Table) return($TableID);
  }
}


function GetTranslatNames($Text,$mode,$TablesColumn) 
{
  global $Database;
  
 /* $TablesID = array('gameobject' => 5,
  'creature' => 6,
  'item' => 4,
  'transports' => 'Name',
  'areatrigger_teleport' => 'Name',
  'areatrigger_tavern' => 'Name',); */
    $buff = array();
  
  foreach($TablesColumn as $Table => $Column) 
  {  
    $sql = 'SELECT `ID`,`'.$Column.'`, (SELECT `'.$Column.'` FROM `'.$Table.'` AS `T` WHERE `O`.`Entry` = `T`.`Entry` AND `Language` <> 0 LIMIT 1) AS `Tran` FROM `'.$Table.'` AS `O` WHERE ';
    $groupby = ' GROUP BY `'.$Column.'`';
  
    $ArrStr = explode(' ', $Text);
    $where = '`Language` = 0 ';
    if ($mode == 1) $where .= ' AND EXISTS(SELECT 1 FROM `'.$Table.'` AS `Sub` WHERE (`Sub`.`Language` <> 0) AND (`Sub`.`Entry` = `O`.`Entry`))';
    if ($mode == 2) $where .= ' AND NOT EXISTS(SELECT 1 FROM `'.$Table.'` AS `Sub` WHERE (`Sub`.`Language` <> 0) AND (`Sub`.`Entry` = `O`.`Entry`))';
    $where .= ' AND ('; 
    
    $SqlOK = false;
    if (count($ArrStr) > 0) {
      for($i = 0; $i < count($ArrStr); $i++)
      {
        if (strpos($ArrStr[$i],"'s") > 0)
       $ArrStr[$i] = substr($ArrStr[$i],0,strlen($ArrStr[$i])-2);
        if (strpos($ArrStr[$i],',') > 0) $ArrStr[$i] = substr($ArrStr[$i],0,strlen($ArrStr[$i])-1);
        if (strpos($ArrStr[$i],'.') > 0) $ArrStr[$i] = substr($ArrStr[$i],0,strlen($ArrStr[$i])-1);
        if (strpos($ArrStr[$i],'!') > 0) $ArrStr[$i] = substr($ArrStr[$i],0,strlen($ArrStr[$i])-1);
        if (strpos($ArrStr[$i],'?') > 0) $ArrStr[$i] = substr($ArrStr[$i],0,strlen($ArrStr[$i])-1);

        if (strlen($ArrStr[$i]) > 4) {
          $where .= '(`O`.`'.$Column.'` LIKE "%'.addslashes($ArrStr[$i]).'%") OR ';
          $SqlOK = true;
      }
      }
      $where = substr($where,0,strlen($where)-4);
      $where .= ')';
      if ($SqlOK) {
        $ID = $Database->SQLCommand($sql.$where.$groupby);
    //  echo ($sql.'|'.$where.'|'.$groupby);
        while($Line = mysql_fetch_assoc($ID)) {
        $buff[] = array($Line['ID'],GetIDbyName($Table),$Line[$Column],$Line['Tran']);
        }
    }
    }
  }
    return $buff;
}

function ProgressBar($Width, $Percent, $Text = '')
{
  $Pixels = $Width * ($Percent / 100);
  if($Pixels > $Width) $Pixels = $Width;
  if($Text == '') $Text = $Percent;
  
  return('<div class="progressbar" style="width: '.$Width.'px">'.
    '<div class="bar" style="width: '.$Pixels.'px;"></div>'.  
    '<div class="text" style="width: '.$Width.'px">'.$Text.'</div>'.  
    '</div>');
}

function GetLevelMinMax($XP)
{
  $IndexLevel = 100;
  
  if($XP > 0) $Level = floor(sqrt($XP / $IndexLevel));
    else $Level = 0;
  $MinXP = $Level * $Level * $IndexLevel;
  $MaxXP = ($Level + 1) * ($Level + 1) * $IndexLevel;
  $MaxXP = $MaxXP - $MinXP;
  $XP = $XP - $MinXP;
  return(array('Level' => $Level, 'XP' => $XP, 'MaxXP' => $MaxXP));
}

?>
